// idbg - IJVM debugger.
// Copyright 2000 Tom Rothamel <tom-idbg@onegeek.org>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  

#include <stdarg.h>
#include "idbg.h"

static int ocount = 0;
int opage = 20;
static FILE *ologf = NULL;

void oreset() {
	ocount = 0;
}

void oprintf(char *fmt, ...) {
	va_list ap;

	curses_hide();

	ocount++;
	if (ocount == opage) {
		readline("[Press enter for more.]");
		ocount = 0;
	}
	
	va_start(ap, fmt);
	vprintf(fmt, ap);
	va_end(ap);

	if (!ologf) return;

	va_start(ap, fmt);
	vfprintf(ologf, fmt, ap);
	va_end(ap);
}

void oprint(char *fmt, ...) {
	va_list ap;

	curses_hide();

	if (ocount + 1 == opage) {
		readline("[Press enter for more.]");
		ocount = 0;
	}

	
	va_start(ap, fmt);
	vprintf(fmt, ap);
	va_end(ap);

	if (!ologf) return;

	va_start(ap, fmt);
	vfprintf(ologf, fmt, ap);
	va_end(ap);
}

void olog(FILE *f) {
	if (ologf) fclose(ologf);
	ologf = f;
}
